(function(){
var additionalData = [
["title.html","NEX Guide",
"NEX Guide\nVersion 1.0\n\tNintendo Confidential\n\tThis document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.No part of this document may be released, distributed, transmitted, or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2015 Nintendo. All rights reserved.\nCTR-06-0015-001-A\nAll company and product names in this document are the trademarks or registered trademarks of their respective companies.\n",0]
,["Pages/Page_79038929.html","1. Introduction ",
"1. Introduction\n This document provides a summary of useful information for planning and developing applications that use the NEX library.\n The NEX Programming Manual contains detailed descriptions of each of the features available in the NEX library but does not cover what can be achieved by using those features together, things to consider when implementing those features in applications, or general information about working with the NEX library. This document is intended to supplement the NEX Programming Manual.\n Also, unlike the NEX Programming Manual, this document contains useful information for users involved in general application planning.\nCONFIDENTIAL\n",0]
,["Pages/Page_79040839.html","2. Development/Usage Overview ",
"2. Development/Usage Overview\nNEX provides ways to simultaneously interact both with server features and client devices. Therefore, using NEX for application development requires keeping both development and usage considerations in mind.\nThis section describes the workflows for developing applications that use NEX.\nWhen using NEX for application development, be aware of the following six major development phases.\n \tPlanning \tDevelopment and Debugging \tLotcheck \tGo Live \tReleasing Patches \tLocalization\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_企画検討","Planning",
"Planning\nThe planning phase involves assessing whether using NEX will allow you to achieve your vision for the application as well as how, specifically, to use NEX in doing so. In this phase, there will not yet be a dedicated game server for your title. However, during this phase you will have access to the sample demo server. The sample demos included in the NEX package connect to this sample demo server. Use the sample demo server to test out the various NEX features and confirm that those features will be suitable for your application.\nOther developers also have access to the sample demo server. Do not upload confidential information regarding your title to the sample demo server or use the sample demo server in a manner that may inconvenience the other developers. The following list contains other important information to consider.\n \tDo not upload proprietary title information to the data store. Do not upload screenshots. \tDo not store title-specific information in the shared ranking data, etc. \tDo not specify the same matchmaking game mode used in the sample demos. \tDo not repeatedly call API functions at a frequency that significantly exceeds the API access frequency limitations established in the guidelines. \tDo not delete data that is not yours. \tDo not use the sample demo server during actual application development.\nHowever, feel free to use the NEX sample programs as is as much as you would like.\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_開発・デバッグ","Development and Debugging",
"Development and Debugging\nThe development and debugging phase begins when application planning is complete and you have a better understanding on how you will be using NEX in your title. During this phase, you will no longer use the sample demo server. Instead, you will use a dedicated game server prepared for your title.\nTo gain access to a dedicated game server, you must submit a NEX usage application on OMAS. For information about applying for use of NEX, contact Nintendo.\nWhen you apply to use NEX, you will need to describe how you will be using the NEX features in your application. Nintendo can still provide a game server even if the low-level details are not yet in place. You may apply to use NEX while you are still working through those details. In this case, however, you should update your NEX usage application when the details become more clear. Consider that if your NEX usage application is not in order, technical support and Lotcheck may proceed less smoothly than they would otherwise.\nOnce a game server has been configured, you can check your game server ID and access key on OMAS. Use this information to connect to the dedicated game server for your title.\nOther titles will not be able to access your dedicated game server until specifically configured to be able to do so. However, there is not a dedicated physical server for each title, rather, virtual servers are run in parallel on the same box. Continue to avoid implementation of features that might cause excessively high server loads.\nThe following list contains other important information to consider.\n \tDo not repeatedly call NEX API functions at a frequency that significantly exceeds the API call frequency limitations established in the guidelines.\nNote: During testing, it is acceptable to simulate high server loads for a short period of time (several minutes at most).\nTo use a different version of the NEX library, the version configured on the game server must be updated in advance. Change the NEX version on your application for use of NEX on OMAS, and Nintendo will update your game server after approval. Game servers are updated within 3 business days of approval.\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_ロットチェック","Lotcheck",
"Lotcheck\nA game server for use during the Lotcheck process must be configured before the Lotcheck phase can begin. Before a server for Lotcheck can be configured, your title must have proceeded to the In Development/Ready for Lotcheck phase on OMAS.\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_サービスイン","Go Live",
"Go Live\nOnce Lotcheck is complete, a production game server will be configured. Once a production game server has been configured, you can connect to it any point. Configuration of the game server is not related to the title's official launch date. You can connect to the game server prior to launch as well. Be careful when implementing features that will not work correctly until after the official launch date.\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_パッチのリリース","Releasing Patches",
"Releasing Patches\nBefore releasing a patch, check whether the unpatched version of the ROM can still communicate properly with the game server. If not, the game server must be configured so that the unpatched ROM can no longer connect to it. To do this, select Yes for the Network Access Restriction When Unpatched and Restart NEX Server When Patch Is Released items when submitting the application for the patch on OMAS.\nIf the NEX version needs to be updated when the patch is released, the version of NEX on the game server must also be updated. In this case, the game server must also be configured so that the unpatched version of the ROM can no longer connect to it.\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_ローカライズ版の開発","Localization",
"Localization\nIf you release a localized version of an existing file, the localized version should use the same game server unless you have a specific reason to do otherwise. To separate matchmaking results, data store data, or ranking data by region, use separate categories and game modes for each region. The game server itself cannot be configured to have separate partitions for each region.\nWhen releasing a patch for a localized version of an application, be careful about communication compatibility with the game server as well as the NEX version. The game server is shared for all regions, so patches that break communication compatibility must be released in all regions at the same time. If you are considering such a scheme, consult in advance with the person who will be in charge of releasing patches and make sure that this will be possible. Patches must also be released at the same time for all regions to change the NEX version on the game server.\nCONFIDENTIAL\n",0]
,["Pages/Page_79041916.html","5. Frequently Asked Questions (FAQ) ",
"5. Frequently Asked Questions (FAQ)\n",0]
,["Pages/Page_79041916.html#PageId_79042118","5.1. Applying for Use/Server Setup",
"This section provides answers to frequently asked questions regarding development of titles that use the NEX library.\n5.1. Applying for Use/Server Setup\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_ゲームサーバーの申請方法がわからない","How do I apply for use of a game server?",
"How do I apply for use of a game server?\nYou can apply for use of a game server on OMAS. An NDID is required to log into OMAS. Contact Nintendo for more information on obtaining an NDID.\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_申請したが、いつサーバーが使用できるようになるかわからない","I have applied for use of a game server. When will I be able to start using it?",
"I have applied for use of a game server. When will I be able to start using it?\nServers are configured within 3 days of when the title enters the server setup phase on OMAS. If your game server has not been configured appropriately, communicate with your Nintendo contact via the OMAS message boards.\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_用意されたサーバーに接続できない","Why can't I connect to the game server?",
"Why can't I connect to the game server?\nTry running the sample demos while they are still configured to connect to the sample demo server. If you cannot successfully connect to the sample demo server, there may be a problem with your network settings or your account settings. Start by checking that all of your settings are configured correctly.\nIf you can successfully connect to the sample demo server but are having issues connecting to the game server for your title, see Why do my game server logins always fail? in 5.2. Login/Common Features and check your settings accordingly.\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_今まで使用できていたサーバーに接続できなくなった","Why did my game server suddenly stop working?",
"Why did my game server suddenly stop working?\nIf the game server has not been accessed for a certain period of time (2 weeks), the game server automatically transitions into a temporarily suspended state. When this happens, the server will return an X06-0502 error (where x is a platform-dependent value) when you attempt to connect.\n",0]
,["Pages/Page_79041916.html#PageId_79042341","5.2. Login/Common Features",
"\n5.2. Login/Common Features\n",0]
,["Pages/Page_79041916.html#Anchor_79042341_ゲームサーバーへのログインに必ず失敗する","Why do my game server logins always fail?",
"Why do my game server logins always fail?\nCheck that your game server ID and access key are correct.\nIn addition, for Wii U titles ensure that your title ID is set correctly.\n",0]
,["Pages/Page_79041916.html#Anchor_79042341_ゲームサーバーへのログイン失敗時に、エラーコードX06-0801が表示される","Why do I get error code X06-0801 when my game server login fails?",
"Why do I get error code X06-0801 when my game server login fails?\nThis error indicates that the error handling for login failures may not be working correctly.\nCheck whether the NgsFacade::GetLastLoginErrorCode() function is getting error codes correctly when the NgsFacade::Login() function fails.\nCONFIDENTIAL\n",0]
,["Pages/Page_79050117.html","3. Important Considerations During Application Development ",
"3. Important Considerations During Application Development\n",0]
,["Pages/Page_79050117.html#PageId_79051086","3.1. General NEX Usage",
"3.1. General NEX Usage\nThis section describes general considerations when using the NEX library.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_初期化・ログイン","Initialization and Login",
"Initialization and Login\nThe NEX library and other libraries must be initialized before logging into the game server.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_ログイン・ログアウト頻度","Login/Logout Frequency",
"Login/Logout Frequency\nLogging in and logging out creates a high server load. Minimize the frequency of logins/logouts as much as possible. For example, if your title includes an offline gameplay mode in which rankings are uploaded to the server at the end of every level, do not log in/log out at the end of every level. Instead, after logging into the game server for the first time, maintain the login state unless you have a specific reason to do otherwise.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_非同期処理実行中のAC切断","AC Disconnection During Asynchronous Processing",
"AC Disconnection During Asynchronous Processing\nIf AC gets disconnected, NEX cannot function normally. Therefore, NEX must be finalized. This is also true when AC gets disconnected while asynchronous processes are still running. If AC gets disconnected during asynchronous processing, cancel the asynchronous processes and finalize NEX. If it is not feasible to cancel the asynchronous processes, just finalize NEX.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_非同期処理のキャンセル","Canceling Asynchronous Processes",
"Canceling Asynchronous Processes\nAlthough it is possible to cancel all asynchronous NEX functions that are currently running, some of the processes may still be completed on the server depending on when the cancellation took place. For example, if you cancel the asynchronous process associated with the MatchmakeExtensionClient::CreateMatchmakeSession function, a matchmaking session may still be created on the server. If the matchmaking session is open to participation, an unmanaged matchmaking session may take place. In general, Nintendo recommends avoiding canceling asynchronous processes unless you have a specific reason to do otherwise.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXのAPIをコールするスレッド","Threads On Which NEX Functions Are Called",
"Threads On Which NEX Functions Are Called\nThe recommended thread mode is ThreadModeUnsafeTransportBuffer. In this thread mode, all NEX functions calls must be made from the same thread. In this thread mode, make all function calls from the same thread regardless of whether the function performs communication, or is implemented as a synchronous process, or an asynchronous process. Alternatively, you can use exclusive control as appropriate.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_ゲームサーバーによって発行される各種IDの取り扱い","Working with IDs Issued by Game Servers",
"Working with IDs Issued by Game Servers\nThe IDs issued by a game server are not unique outside of that game server. Not only are these IDs not unique across different titles, they are not unique across the various server environments for the same title (development environment, Lotcheck environment, production environment). As a result, be careful when working with these IDs on an independent server or similar. For example, data IDs for data in the data store may be the same for data from the Lotcheck environment and data from the production environment. Do not manage data solely by data ID on your independent server because there may be duplicate data IDs. When saving IDs issued by the game server on your independent server, include the environment metadata included in the service token.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXで扱う事の出来るデータ数","NEX Data Size Limits",
"NEX Data Size Limits\nNEX can handle up to 10 million pieces of data for each of the following modules: rankings, matchmaking, and data stores. Data in excess of these limits may impact server performance to the point that the user experience is negatively affected. Data stores are designed to handle up to 10 million pieces of data regardless of whether a dedicated storage server is used. For example, if you predict that your title will have 100,000 unique users and each of those users uploads 100 pieces of data, the total number of pieces of data will be 10 million. For rankings, each user can only post one score to each ranking category. Therefore, if you predict that your title will have 100,000 unique users and you have 100 ranking categories, the total number of pieces of data may reach 10 million. For matchmaking, in most cases the number of matchmaking sessions will never exceed 10 million. However, as a precaution, make sure to close matchmaking sessions that are no longer in use.\nContact Nintendo on the OMAS message boards (or similar) in advance if you think that your title may generate more than 10 million pieces of data.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_サーバー設定の自動コピー","Automatic Copying of Server Settings",
"Automatic Copying of Server Settings\nGame server settings configured on NMAS are automatically copied to the Lotcheck environment and the production environment when setting up each. Therefore, if you need to update your game server settings on NMAS, make sure to do so before starting the Lotcheck phase. You can still use NMAS to modify the settings for the development environment and the production environment after the respective servers are set up. If you need to change your server settings for the Lotcheck environment after the Lotcheck server has been set up, communicate with your Lotcheck contact directly.\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXサーバーに接続するために必要な接続環境","Connection Environment Required to Connect to the NEX Server",
"Connection Environment Required to Connect to the NEX Server\nSimply configuring your machines to access the server IP address and port number displayed on OMAS may not necessarily make it possible to connect to the NEX server. The NEX server cannot be accessed from a dedicated company LAN or other restricted connection environments by simply configuring your machines to access the IP address and port number displayed on OMAS. Nintendo cannot release all of the IP addresses needed to access the NEX server. Use an unrestricted network environment to access the NEX server.\n",0]
,["Pages/Page_79050117.html#PageId_79051174","3.2. Rankings",
"\n3.2. Rankings\nThis section describes general considerations to consider when using the ranking features.\n",0]
,["Pages/Page_79050117.html#Anchor_79051174_RankingConstants::ORDER_CALCULATION_123の動作","Using RankingConstants::ORDER_CALCULATION_123",
"Using RankingConstants::ORDER_CALCULATION_123\nWhen RankingConstants::ORDER_CALCULATION_123 is specified and there are several instances of the same score, older scores are ranked higher. Furthermore, if the same user uploads the same score, the score data is also updated. This means that the score may be ranked lower than it was previously.\nIf you are using RankingConstants::TIME_SCOPE_ALL for your time scope or just filtering scores by periodically resetting them, you can prevent the order in which scores are ranked from changing when a score equal to a score that has already been uploaded is posted. This is performed by not uploading the newer instance of the score.\nIf your time scope is defined as some period of time relative to the present, the date score uploaded must be updated even if the score is equal to an existing score, so the method above will not work. This is by design.\n",0]
,["Pages/Page_79050117.html#PageId_79051192","3.3. Matchmaking",
"\n3.3. Matchmaking\nThis section describes general considerations to keep in mind when using the matchmaking features.\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_マッチメイク選択条件としてMATCHMAKE_SELECTION_METHOD_SCORE_BASEDを使用する場合","Using MATCHMAKE_SELECTION_METHOD_SCORE_BASED as a Matchmaking Selection Condition",
"Using MATCHMAKE_SELECTION_METHOD_SCORE_BASED as a Matchmaking Selection Condition\nContact Nintendo in advance on the OMAS message boards (or similar) if you are considering using MATCHMAKE_SELECTION_METHOD_SCORE_BASED as a matchmaking session selection condition in conjunction with parameters other than the examples provided in the Server Services > Web API > Score-Based Auto-Matchmaking Feature section of the NEX Programming Manual. Depending on how you configure these parameters, you might not obtain the intended search results when searching matchmaking sessions.\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_マッチメイクセッションの空き部屋","Empty Matchmaking Sessions",
"Empty Matchmaking Sessions\nLeaving a large number of unclosed (empty) matchmaking sessions on the game server will increase the cost of searching matchmaking sessions and may negatively impact overall game server performance. Make sure to close matchmaking sessions that are no longer being used by the application.\nMoreover, although unlikely if you are using the auto-matchmaking feature, if you are using the MatchmakeExtensionClient::BrowseMatchmakeSession and MatchmakeExtensionClient::JoinMatchmakeSession functions to implement your own matchmaking scheme, some search conditions may cause matchmaking sessions to never be found and a large number of empty sessions to be left on the server. If no matchmaking sessions can be found, consider specifying MATCHMAKE_SYSTEM_TYPE_ANYBODY as a search condition and joining the sessions that are retrieved in order to fill up the empty rooms.\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_パスワード制限付きマッチメイクセッションの検索","Searching for Password-Protected Matchmaking Sessions",
"Searching for Password-Protected Matchmaking Sessions\nMatchmaking sessions can be configured to have a password in order to allow specific users to matchmake with each other. If you include such password-protected matchmaking sessions in your search results by default, the number of matchmaking sessions that other users can join may decrease. This makes it necessary for users to repeatedly search for a matchmaking session, which both degrades the user experience and increases the server load. Therefore, Nintendo recommends excluding password-protected matchmaking sessions from the search results when searching for matchmaking sessions using the MatchmakeExtensionClient::BrowseMatchmakeSession function.\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_オートマッチのマッチメイク条件が一つである場合の注意","Auto-Matchmaking With a Single Matching Condition",
"Auto-Matchmaking With a Single Matching Condition\nIf you choose to use auto-matchmaking and only have a single search condition for matchmaking sessions, the server load may increase drastically when there are a large number of users looking for a matchmaking session at the same time. If you predict that your title will have a large number of simultaneously connected users looking for a match, consider using game modes to divide matchmaking sessions into two or three categories behind-the-scenes. Perform this in a way that still makes it still appear like the search conditions are the same to the user, for example. Contact Nintendo during the planning phase of your title if you predict a large number of simultaneously connected users and cannot use a workaround such as dividing up matchmaking sessions into different categories.\n",0]
,["Pages/Page_79050117.html#PageId_79051194","3.4. Data Stores",
"\n3.4. Data Stores\nThis section describes general considerations to keep in mind when using data stores.\n",0]
,["Pages/Page_79050117.html#Anchor_79051194_データの検索条件","Data Search Conditions",
"Data Search Conditions\nYou can use tags specified when data is uploaded to search for data in a data store. However, server performance may suffer if the tagging scheme causes most data to be tagged in the same way. For example, if data is tagged with categories that represents the country of origin such as \"jp\" and \"us\", all data that is uploaded will have one of these tags. If you then try to use one of these tags to search for data in the data store, there will be a large number of matching records in the database. This results in high server load and slow search performance.\nTherefore, make sure to design your tagging scheme and tag searches in a way that prevents this type of tag concentration from occurring. If you want to categorize data by country of origin as in the example above, Nintendo recommends also adding a tag that represents the data type.\nCONFIDENTIAL\n",0]
,["Pages/Page_79061233.html","4. Tips and Tricks ",
"4. Tips and Tricks\n",0]
,["Pages/Page_79061233.html#PageId_79061294","4.1. Rankings",
"4.1. Rankings\nThis section provides a variety of tips and tricks for using the ranking features.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_多くのカテゴリでランキングを使用したい","Using a Large Number of Ranking Categories",
"Using a Large Number of Ranking Categories\nThe RankingClient::GetRanking() function only allows you to specify one category at a time. If you are using a large number of categories, this function has to be called at least as many times as there are categories. However, ranking functions are subject to a call frequency limitation of 15 times per 5 minutes. This means that it is only possible to get the rankings for a maximum of 15 categories every 5 minutes.\nTo work around this issue, you can use cached rankings, although there are also some restrictions on this method as well. Use the RankingClient::GetCachedTopXRanking() function to get cached rankings. This function can get a total of 100 top rankings across multiple categories. For example, this function can get the top 5 rankings for 20 categories.\nCached rankings can also be accessed more frequently than when using the other ranking-related functions, up to 20 times per 5 minutes. This function can get the top 5 rankings for 400 categories over the course of 5 minutes, for example.\nHowever, when using cached rankings, it may take up to 5 minutes for a newly uploaded score to appear in the rankings (even if the local user uploads the score). Therefore, the local user's score may not appear in the rankings if the top rankings are retrieved immediately after the score is uploaded. The RankingCachedResult::LocalUpdate() function was created to solve this problem. This function sets the local user's score and then merges rankings with the local user's ranking when the rankings are retrieved.\nThe number of categories that use cached rankings can be configured on NMAS. This setting cannot be configured from the client side.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_色々なランキングを高い頻度で使用したい","Accessing Rankings with a High Frequency",
"Accessing Rankings with a High Frequency\nIf the call frequency limitations on the RankingClient::GetCachedTopXRanking() function are still too restrictive or you want to retrieve rankings other than the top rankings at a very high frequency, consider using the Ranking2 module.\n In the Ranking2 module, the function for getting rankings (Ranking2Client::GetRanking()) can be called up to 20 times per minute. In addition, the numbers of calls to each API function are counted independently.\n However, the Ranking2 module is designed somewhat differently from the normal ranking module and has its own limitations. For example, the Ranking2 module does not allow you to filter scores by groups.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_ランキングにたくさんのスコアを登録してデバッグをしたい","Uploading a Large Number of Dummy Scores to a Ranking Category for Debugging",
"Uploading a Large Number of Dummy Scores to a Ranking Category for Debugging\nNintendo strongly recommends uploading dummy data when debugging your implementation of a ranking feature. Some of the NEX ranking API functions have a restriction on the number of ranked scores that can be retrieved and may behave differently depending on the total number of ranked scores. In particular, these functions only support offset values (a value set to get a range of ranked scores starting from the offset) less than 1000. These functions will return an error if an offset greater than or equal to 1000 is specified when they are called. Uploading dummy data allows you to test different workflows for getting rankings based on the total number of ranked scores.\nDummy data can be uploaded using NMAS. Nintendo recommends uploading at least 1500 dummy scores. However, do not upload more than 1 million dummy scores in total because doing so may cause an extremely high server load. Furthermore, uploading dummy data takes a non-negligible amount of time. Nintendo recommends starting from a lower number of dummy scores and gradually increasing the number to obtain the desired number of dummy scores.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_バージョンアップでランキングの互換を切りたい","Breaking Ranking Compatibility in Application Updates",
"Breaking Ranking Compatibility in Application Updates\nIf you want to prevent the intermingling of ranked scores from the pre- and post-updated versions of an application, Nintendo recommends changing the ranking categories as well as the categories to which scores are uploaded in order to break ranking compatibility.\nWhile it is possible to make the application update mandatory and reset ranking data, this requires careful organization when the update is released, when the server will be reset, and when all of the users will be disconnected from the server in order to do so. Furthermore, titles that are available in several regions use the same game server. Breaking compatibility using the latter method would therefore require releasing the update simultaneously in all regions worldwide. Nintendo recommends using the former method of reconfiguring categories to break ranking compatibility whenever possible.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_リージョン毎にランキングを分けたい","Separating Rankings by Region",
"Separating Rankings by Region\nThe game server itself cannot be partitioned for each region. To separate rankings by region, use different categories for each region.\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_データストアと連携したい","Linking with Data Stores",
"Linking with Data Stores\nIf you want to include information about the user when uploading a score to the rankings, upload that user data to a data store and associate it with the ranked score.\nTo perform this, upload the desired user information to the data store in advance and associate a data ID with that data. Then, when calling the RankingClient::UploadScore() function, set the data store data ID as one of the parameters in the RankingScoreData object. Doing this allows you to download the data associated with that data ID on the data store when the user retrieves the rankings.\n",0]
,["Pages/Page_79061233.html#PageId_80121852","4.2. Matchmaking",
"\n4.2. Matchmaking\nThis section provides a variety of tips and tricks for using the matchmaking features.\n",0]
,["Pages/Page_79061233.html#Anchor_80121852_バージョンアップ時に、バージョンアップ前後のソフト同士でマッチメイクしないようにしたい","Disabling Matchmaking Between Clients Using the Pre- and Post-Updated Versions of an Application After an Application Update",
"Disabling Matchmaking Between Clients Using the Pre- and Post-Updated Versions of an Application After an Application Update\nIf you want to disable matchmaking between clients using the pre- and post-updated versions of an application before or after an application update, Nintendo recommends changing the game modes as well as search conditions.\nWhile it is possible to make the application update mandatory after the update is released for all users to access the server, this requires carefully organizing when the update is released, when the server will be reset, and when all of the users will be disconnected from the server in order to do so. Furthermore, titles that are available in several regions use the same game server. Breaking compatibility using the latter method would therefore require releasing the update simultaneously in all regions worldwide. Therefore, Nintendo recommends the former method of simply changing the game modes accordingly.\nModifying game modes to support release of an application update may have the unwanted side effect of decreasing the matchmaking success rate due to the increased number of game modes. To prevent users from being distributed across several game modes, Nintendo recommends rejecting authentication of clients using the old version of the application. Rejecting authentication of clients using the old version of the application on the account server and the authentication server after the patch is released, makes it possible to guarantee that users who successfully log into the game server have installed the latest patch. For more information on guaranteeing that clients have installed the latest patch, see the Releasing Patches section in 2. Development/Usage Overview.\n",0]
,["Pages/Page_79061233.html#PageId_80122292","4.3. Data Stores",
"\n4.3. Data Stores\nThis section provides a variety of tips and tricks for using the data store features.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_データの保存場所を組み合わせて使用したい（ストレージサーバーとゲームサーバー）","Using Both a Storage Server and the Game Server",
"Using Both a Storage Server and the Game Server\nWhen using the data store feature to save data, that data can be saved on a storage server or on the game server.\nThe table below details some of the advantages and disadvantages of each method.\n \t \tStorage Server \tGame Server\n \tMaximum size for a single piece of data. \t10 MB \t1024 bytes\n \tNumber of pieces of data that can be downloaded/uploaded at once. \t1 \t100\n \tSpecifying a data ID when uploading data. \tNo \tYes\n \tProcessing speed. \tSlower than when using the game server. \t-\n However, by using both a storage server and the game server in combination, you can take full advantage of each. For example, you could store replay data on the storage server and the thumbnails for that data on the game server, and then just get all of the thumbnails and only get the actual replay data from the storage server when necessary.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_カウンターとしてデータストアを使用したい","Using Data Stores as a Counter",
"Using Data Stores as a Counter\nData stores can be used to store data that functions as a counter for actions taken by game players or ratings submitted by game players.\nFor example, you could implement a voting feature by having clients evaluate some piece of data that was uploaded in advance, and then totaling the submitted user values. For instance, you could set the possible values for users to submit to 0 and 1 and allow users to change their votes, but also implement a lock on duplicate votes to only allow each user to submit a single vote to let users vote on some condition for a given period of time.\nTo use data stores as a counter across the entire game, someone has to upload the data. In this case, you can enable specification of a data ID when data is uploaded to ensure that data is only uploaded when data with that data ID has not been already been uploaded. In this case, the system attempts to upload the user value/rating but only succeeds in doing so if the corresponding data does not already exist.\nNegative values can also be specified and used freely as global variables for game participants, for example.\nHowever, relative comparison of these values is not supported, so you cannot filter data by values greater than or equal to a certain value.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_ランダムなデータを取得したい","Getting Random Data",
"Getting Random Data\nTo retrieve uploaded data at random, specify RESULTRANGE_ANY_OFFSET as the offset for the data to retrieve. This makes the server return pseudo-randomly selected data. Doing this makes it possible to prevent getting the same data every time.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_バージョンアップで、データの互換性を切りたい","Breaking Data Compatibility with an Application Update",
"Breaking Data Compatibility with an Application Update\nIf you want to prevent intermingling of data from the pre- and post-updated versions of an application in a data store before or after an application update, Nintendo recommends changing the data types as well as the locations to which data is uploaded in order to break data store compatibility.\nWhile it is possible to make the application update mandatory after the update is released, this requires carefully organizing when the update is released, when the server will be reset, and when all of the users will be disconnected from the server in order to do so. Furthermore, titles that are available in several regions use the same game server. Breaking compatibility using the latter method would therefore require releasing the update simultaneously in all regions worldwide. Nintendo recommends using the former method of simply changing the data types whenever possible.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_ネットワーク経由で疑似的なすれちがい通信を行いたい","Distributing Pseudo-StreetPass Communications Over a Network",
"Distributing Pseudo-StreetPass Communications Over a Network\nPseudo-StreetPass communications can be implemented by using data stores to categorize data by received and unreceived data. For example, you can specify a data type of 1 when uploading data that you want to use for StreetPass, and then later get one of the pieces of data with a data type of 1 by specifying the appropriate search conditions. Once a user has obtained this data, the data type can be changed to 0 to ensure that that user does not receive the same data again. This also allows the user that uploaded the data to see which data was downloaded later.\nThis type of data could also potentially be categorized and searched using tags. However, this implementation is not recommended because as described in 3.4. Data Stores, NEX data stores are not designed to handle searching through extremely large numbers of similarly tagged pieces of data. The server load increases proportionally to the total number of pieces of data, and this implementation may degrade the service and the user experience.\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_いつの間に通信との連携を行いたい","Linking with SpotPass",
"Linking with SpotPass\nData can be uploaded and downloaded to and from a data store server via SpotPass. For more information, see the Programming Manual - SpotPass.\nIt is also possible to use the NEX library in combination with SpotPass, such as to upload data to a data store server using the NEX library and then use SpotPass to download that data, for example.\nCONFIDENTIAL\n",0]
,["Pages/Page_92335117.html","6. Revision History ",
"6. Revision History\n \tRevision Date \tCategory \tChanges\n \t2015-08-20 \t- \tInitial version.\nCONFIDENTIAL\n",0]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
